Index: src/perl/register-dataset.cgi
===================================================================
--- src/perl/register-dataset.cgi	(revision 5310)
+++ src/perl/register-dataset.cgi	(revision 5311)
@@ -2906,554 +3596,677 @@
 #
 ################################################################################
 sub getCredentials {
-    my $userDN = $FORM::username;
-    my $userOrg = $FORM::organization;
-    my $userPass = $FORM::password;
-    my $dname = "uid=$userDN,o=$userOrg,dc=ecoinformatics,dc=org";
+	my $userDN   = $FORM::username;
+	my $userOrg  = $FORM::organization;
+	my $userPass = $FORM::password;
+	my $dname    = "uid=$userDN,o=$userOrg,dc=ecoinformatics,dc=org";
 
-    my $session = CGI::Session->load();
-    if (!($session->is_empty || $session->is_expired)) {
-        $dname = $session->param("username");
-        $userPass = $session->param("password");
-    }
+	my $session = CGI::Session->load();
+	if ( !( $session->is_empty || $session->is_expired ) ) {
+		$dname    = $session->param("username");
+		$userPass = $session->param("password");
+	}
 
-    return ($dname, $userPass);
+	return ( $dname, $userPass );
 }
 
 ################################################################################
-# 
+#
+# get user groups from metacat for the currently logged in user
+#
+################################################################################
+sub getUserGroups {
+	my $sessionId = shift;
+	
+	#debug("getting user info for session id: $sessionId");
+	my $metacat = Metacat->new($metacatUrl);
+	
+	my ( $username, $password ) = getCredentials();
+	$metacat->login( $username, $password );
+	
+	my $userInfo = $metacat->getUserInfo($sessionId);
+	
+	debug("user info xml: $userInfo");
+	
+	my $parser = XML::LibXML->new();
+	my $parsedDoc = $parser->parse_string($userInfo);
+	
+	my $groupString = $parsedDoc->findvalue('//user/groupNames');
+	
+	my @groupArray;
+	foreach (split(":", $groupString)) {
+		$_ =~ s/^\s+//;
+		$_ =~ s/\s+$//;
+		debug("pushing: $_");
+		push(@groupArray, $_);
+	}
+
+	return @groupArray;
+}
+
+################################################################################
+#
 # function to check if the moderator is logged in - if yes, then username and
 # password are set
 #
 ################################################################################
 sub isModerator {
-    my $stage = shift;
+	my $stage = shift;
 
-    my $returnValue = 1;
+	my $returnValue = 1;
 
-    # Check if the session exists
-    my $session = CGI::Session->load();
-    if ($session->is_empty || $session->is_expired) {
-        # no session found ... send back to index.html page ... 
-        processResultTemplate($stage, 'failure', "Moderator is not logged in.\n");
-        $returnValue = -1;
-    } 
+	# Check if the session exists
+	my $session = CGI::Session->load();
+	if ( $session->is_empty || $session->is_expired ) {
 
-    # check if logged in user is moderator
-    my $moderator = $session->param("moderator");
-    if ($moderator ne 'true') {
-        # no session found ... send back to index.html page ... 
-        debug("Logged in user is not moderator");
-        processResultTemplate($stage, 'failure', "Logged in user is not moderator.\n");
-        $returnValue = -1;
-    }
+		# no session found ... send back to index.html page ...
+		processResultTemplate( $stage, 'failure',
+			"Moderator is not logged in.\n" );
+		$returnValue = -1;
+	}
 
-    if ($returnValue eq 1) {
-        ($modUsername, $modPassword) = getCredentials();
-    }
+	# check if logged in user is moderator
+	my $moderator = $session->param("moderator");
+	if ( $moderator ne 'true' ) {
 
-    return $returnValue;
+		# no session found ... send back to index.html page ...
+		debug("Logged in user is not moderator");
+		processResultTemplate( $stage, 'failure',
+			"Logged in user is not moderator.\n" );
+		$returnValue = -1;
+	}
+
+	if ( $returnValue eq 1 ) {
+		( $modUsername, $modPassword ) = getCredentials();
+	}
+
+	return $returnValue;
 }
 
 sub handleRead {
-    my $docid = $FORM::docid;
-    my $errorMessage;
-    #debug("\n\n\n\n$docid");
-    print "Content-type: text/html\n\n";
+	my $docid = $FORM::docid;
+	my $sessionId = $FORM::sessionid;
+	my $errorMessage;
 
-    # Check if the session exists
-    my $session = CGI::Session->load();
-    if ($session->is_empty || $session->is_expired) {
-        # no session found ... send back the regular read page ...
-        my $url = "$skinsDir/$skinName/index.html";
-        redirect($url);
-    } else {
-        my $htmldoc = qq|<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Frameset//EN" "http://www.w3.org/TR/html4/frameset.dtd">
+	#debug("\n\n\n\n$docid");
+	print "Content-type: text/html\n\n";
+
+	# Check if the session exists
+	my $session = CGI::Session->load();
+	if ( $session->is_empty || $session->is_expired ) {
+
+		# no session found ... send back the regular read page ...
+		my $url = "$skinsDir/$skinName/index.html";
+		redirect($url);
+	}
+	else {
+		my $htmldoc =
+qq|<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Frameset//EN" "http://www.w3.org/TR/html4/frameset.dtd">
         <html><head><title>Dataset Description: $docid</title><meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"></head>
           <frameset rows="150,*" cols="*" frameborder="NO" border="0" framespacing="0">
             <frame src="$skinsDir/$skinName/header.jsp" marginwidth="40" name="topFrame" scrolling="NO" noresize>
             <frameset cols="200,*" frameborder="NO" border="0" framespacing="0">
               <body></body><frame src="$cgiPrefix/register-dataset.cgi?cfg=$skinName&stage=review_frame&docid=$docid" name="rightFrame" scrolling="NO" noresize></frame>
-              <frame src="$metacatUrl?action=read&qformat=$skinName&docid=$docid&insertTemplate=0" name="mainFrame">
+              <frame src="$metacatUrl?action=read&qformat=$skinName&docid=$docid&insertTemplate=0&sessionid=$sessionId" name="mainFrame">
             </frameset>
           </frameset>
         </html>
 |;
-        print $htmldoc;    
-    }
+		print $htmldoc;
+	}
 }
 
 sub handleReviewFrame {
-    print "Content-type: text/html\n\n";
-    my $session = CGI::Session->load();
-        if ($session->is_empty || $session->is_expired) {
-        return;
-    }
+	print "Content-type: text/html\n\n";
+	my $session = CGI::Session->load();
+	if ( $session->is_empty || $session->is_expired ) {
+		return;
+	}
 
-    my $moderator = $session->param("moderator");
-    $$templateVars{'reviewdocid'} = getReviewHistoryHTML();
-    $$templateVars{'docid'} = $FORM::docid;
-    if ($moderator eq 'true') {
-        $$templateVars{'isModerator'} = "true";
-    }
-    $template->process($templates->{'getReviews'}, $templateVars);
+	my $moderator = $session->param("moderator");
+	$$templateVars{'reviewdocid'} = getReviewHistoryHTML();
+	$$templateVars{'docid'}       = $FORM::docid;
+	if ( $moderator eq 'true' ) {
+		$$templateVars{'isModerator'} = "true";
+	}
+	$template->process( $templates->{'getReviews'}, $templateVars );
 }
 
 sub getReviewHistoryHTML {
-    my $metacat = Metacat->new($metacatUrl);
-    my ($username, $password) = getCredentials();
-    $metacat->login($username, $password);
-    my $parser = XML::LibXML->new();
-    my $docid = $FORM::docid;
-    my ($x, $y, $z) = split(/\./, $docid);
-    if ($x eq "") {
-        return "Error: Unable to find review for invalid docid.";
-    }
-    my $docidWithoutRev = $x.".".$y;
-    my $reviewDocumentId = '';
-    my $reviewQuery = "<pathquery><querytitle>Moderator-Search</querytitle><querygroup operator='INTERSECT'><queryterm searchmode='contains' casesensitive='false'><value>$docidWithoutRev</value><pathexpr>/reviewHistory/review/packageId</pathexpr></queryterm></querygroup></pathquery>";
-    my $response = $metacat->squery($reviewQuery);
-    my $doc = $response->content();
-    my $xmldoc = $parser->parse_string($doc);
-    my $reviewHTML = '';
+	my $metacat = Metacat->new($metacatUrl);
+	my ( $username, $password ) = getCredentials();
+	$metacat->login( $username, $password );
+	my $parser = XML::LibXML->new();
+	my $docid  = $FORM::docid;
+	my ( $x, $y, $z ) = split( /\./, $docid );
+	if ( $x eq "" ) {
+		return "Error: Unable to find review for invalid docid.";
+	}
+	my $docidWithoutRev  = $x . "." . $y;
+	my $reviewDocumentId = '';
+	#debug("find review history for docid $docidWithoutRev");
+	my $reviewQuery = "<pathquery><querytitle>Moderator-Search</querytitle><querygroup operator='INTERSECT'><queryterm searchmode='contains' casesensitive='false'><value>$docidWithoutRev</value><pathexpr>/reviewHistory/review/packageId</pathexpr></queryterm></querygroup></pathquery>";
+	my $response   = $metacat->squery($reviewQuery);
+	my $doc        = $response->content();
+	my $xmldoc     = $parser->parse_string($doc);
+	my $reviewHTML = '';
 
-    if ($xmldoc eq "" || $doc=~ /<error/) {
-        # not able to parse
-        return "Error: Unable to search for review for the docid:".$docid;
-    } else {
-        my $findNodes = $xmldoc->findnodes('//resultset/document');
-        if ($findNodes->size() > 0) {
-            # found contact email address
-            my $node = '';
-            foreach $node ($findNodes->get_nodelist) {
-                $reviewDocumentId = findValue($node,'docid');
-            }
-        }
-    }
-    return $reviewDocumentId;
+	if ( $xmldoc eq "" || $doc =~ /<error/ ) {
+
+		# not able to parse
+		return "Error: Unable to search for review for the docid:" . $docid;
+	}
+	else {
+		my $findNodes = $xmldoc->findnodes('//resultset/document');
+		if ( $findNodes->size() > 0 ) {
+			#debug("//resultset/document section found");
+			# found contact email address
+			my $node = '';
+			foreach $node ( $findNodes->get_nodelist ) {
+				$reviewDocumentId = findValue( $node, 'docid' );
+			}
+		}
+	}
+	return $reviewDocumentId;
 }
 
 ################################################################################
-# 
-# function to handle accept request for moderator  
 #
+# function to handle accept request for moderator
+#
 ################################################################################
-sub handleModAccept(){
+sub handleModAccept() {
 
-    my $errorMessage = '';
-    my $metacat = Metacat->new($metacatUrl);
+	my $errorMessage = '';
+	my $metacat      = Metacat->new($metacatUrl);
 
-    print "Content-type: text/html\n\n";
+	print "Content-type: text/html\n\n";
 
-    debug("Stage is mod_accept");
+	debug("Stage is mod_accept");
 
-    my $isMod = isModerator("accept");
-    if ($isMod < 0) {
-        return;
-    }
+	my $isMod = isModerator("accept");
+	if ( $isMod < 0 ) {
+		return;
+	}
 
-    # read the document from 
-    my $parser = XML::LibXML->new();
-    my $title = '';
-    my $contactEmailAddress = '';
-    my $contactName = '';
-    my $userDN = '';
-    # Log into metacat
-    my $response = $metacat->login($modUsername, $modPassword);
-    my $docid = $FORM::docid;
+	# read the document from
+	my $parser              = XML::LibXML->new();
+	my $title               = '';
+	my $contactEmailAddress = '';
+	my $contactName         = '';
+	my $userDN              = '';
 
-    if (!$response) {
-        # Could not login
-        $errorMessage = $errorMessage." Failed during moderator login.";
-    } else {
-        # read the document and get the contact name and address
-        $response = $metacat->read($docid);
-        my $docFromMetacat = $response->content();
-        my $xmldoc = $parser->parse_string($docFromMetacat);
-        my $dataElem = '';
-        my $results;
+	# Log into metacat
+	my $response = $metacat->login( $modUsername, $modPassword );
+	my $docid = $FORM::docid;
 
-        if ($xmldoc eq "" || $docFromMetacat=~ /<error/) {
-            # not able to parse
-            $errorMessage = $errorMessage." Error in reading the following docid:".$docid;
-        } else {
-            my $emldoc = '';
-            $xmldoc = transformEml($xmldoc);
-          
-            # pull out existing dataset entry 
-            $results = $xmldoc->findnodes('//dataset');
-            foreach my $r ($results->get_nodelist) {
-                $dataElem .= $r->toString();
-            }
-            
-            $emldoc .= EMLStart();
-            $emldoc .= accessElement("true");
-            $emldoc .= $dataElem;
-            $emldoc .= EMLEnd();
+	if ( !$response ) {
 
-            #debug("Document created by handleModAccept is " . $emldoc);
-            # update the document
-            my $docid = incrementRevision($docid);
+		# Could not login
+		$errorMessage = $errorMessage . " Failed during moderator login.";
+	}
+	else {
 
-            $emldoc =~ s/packageId="docid"/packageId=\"$docid\"/;
-            debugDoc($emldoc);
-            $response = $metacat->update($docid, $emldoc);
+		# read the document and get the contact name and address
+		$response = $metacat->read($docid);
+		my $docFromMetacat = $response->content();
+		my $xmldoc         = $parser->parse_string($docFromMetacat);
+		my $dataElem       = '';
+		my $results;
 
-            if (! $response) {
-                debug("Error while updating in handleModAccept.");
-                #push(@errorMessages, $metacat->getMessage());
-                $errorMessage = $errorMessage." Failed while updating the document with new access rules.";  
-            }
+		if ( $xmldoc eq "" || $docFromMetacat =~ /<error/ ) {
 
-            # get the contact email address from the 
-            $xmldoc = $parser->parse_string($emldoc);
+			# not able to parse
+			$errorMessage =
+			  $errorMessage . " Error in reading the following docid:" . $docid;
+		}
+		else {
+			my $emldoc = '';
+			$xmldoc = transformEml($xmldoc);
 
-            if ($xmldoc eq "" || $xmldoc=~ /<error/) {
-                # not able to parse
-                $errorMessage = $errorMessage." Error in reading the docid:".$docid;
-            } else {
-                my $findNodes = $xmldoc->findnodes('//dataset/contact');
-                if ($findNodes->size() > 0) {
-                    # found contact email address
-                    my $node = '';
-                    foreach $node ($findNodes->get_nodelist) {
-                        $contactEmailAddress = findValue($node,'electronicMailAddress');
-                        my $surName = findValue($node,'individualName/surName');
-                        my $givenName = findValue($node,'individualName/givenName');
-                        my $organizationName = findValue($node,'organizaitionName');
+			# pull out existing dataset entry
+			$results = $xmldoc->findnodes('//dataset');
+			foreach my $r ( $results->get_nodelist ) {
+				$dataElem .= $r->toString();
+			}
 
-                        if ($surName ne '') {
-                            $contactName = $givenName.' '.$surName;
-                        } else {
-                            $contactName = $organizationName;
-                        }
-                    }
-                } else {
-                    $contactEmailAddress = '';
-                }
-                $findNodes = $xmldoc->findnodes('//dataset/title');
-                if ($findNodes->size() > 0) {
-                    # found title
-                    my $node = '';
-                    foreach $node ($findNodes->get_nodelist) {
-                        $title = findValue($node,'../title');
-                    }
-                } else {
-                    $title = '';
-                }
+			$emldoc .= EMLStart();
+			$emldoc .= accessElement("true");
+			$emldoc .= $dataElem;
+			$emldoc .= EMLEnd();
 
-                $findNodes = $xmldoc->findnodes('//access/allow');
-                if ($findNodes->size() > 0) {
-                    # found title
-                    my $node = '';
-                    foreach $node ($findNodes->get_nodelist) {
-                        my $perm = findValue($node,'permission');
-                        if ($perm ne 'all') {
-                            $userDN = findValue($node,'principal');
-                        }
-                    }
-                } else {
-                    $userDN = '';
-                }
-            }
-        }
-    }
+			#debug("Document created by handleModAccept is " . $emldoc);
+			# update the document
+			my $docid = incrementRevision($docid);
 
-    # give the system a chance to finish databasing and indexing
-    sleep(5);
+			$emldoc =~ s/packageId="docid"/packageId=\"$docid\"/;
+			debugDoc($emldoc);
+			$response = $metacat->update( $docid, $emldoc );
 
-    # send notification to the user and the moderator
-    if ($errorMessage eq '') {
-        modSendNotification($title, $contactEmailAddress, $contactName, "Document $docid Accepted");
-        if ($FORM::review ne '') {
-            $errorMessage = modStoreReview('accept', $metacat, $userDN);
-            if ($errorMessage ne '') {
-                processResultTemplate('accept', 'failure', $errorMessage);
-                return;
-            }
-        }
-        # send notifications
-        processResultTemplate('accept', 'success', $errorMessage);
-    } else {
-        processResultTemplate('accept', 'failure', $errorMessage);
-    }
+			if ( !$response ) {
+				debug("Error while updating in handleModAccept.");
+
+				#push(@errorMessages, $metacat->getMessage());
+				$errorMessage = $errorMessage
+				  . " Failed while updating the document with new access rules.";
+			}
+
+			# get the contact email address from the
+			$xmldoc = $parser->parse_string($emldoc);
+
+			if ( $xmldoc eq "" || $xmldoc =~ /<error/ ) {
+
+				# not able to parse
+				$errorMessage =
+				  $errorMessage . " Error in reading the docid:" . $docid;
+			}
+			else {
+				my $findNodes = $xmldoc->findnodes('//dataset/contact');
+				if ( $findNodes->size() > 0 ) {
+
+					# found contact email address
+					my $node = '';
+					foreach $node ( $findNodes->get_nodelist ) {
+						$contactEmailAddress =
+						  findValue( $node, 'electronicMailAddress' );
+						my $surName =
+						  findValue( $node, 'individualName/surName' );
+						my $givenName =
+						  findValue( $node, 'individualName/givenName' );
+						my $organizationName =
+						  findValue( $node, 'organizaitionName' );
+
+						if ( $surName ne '' ) {
+							$contactName = $givenName . ' ' . $surName;
+						}
+						else {
+							$contactName = $organizationName;
+						}
+					}
+				}
+				else {
+					$contactEmailAddress = '';
+				}
+				$findNodes = $xmldoc->findnodes('//dataset/title');
+				if ( $findNodes->size() > 0 ) {
+
+					# found title
+					my $node = '';
+					foreach $node ( $findNodes->get_nodelist ) {
+						$title = findValue( $node, '../title' );
+					}
+				}
+				else {
+					$title = '';
+				}
+
+				$findNodes = $xmldoc->findnodes('//access/allow');
+				if ( $findNodes->size() > 0 ) {
+
+					# found title
+					my $node = '';
+					foreach $node ( $findNodes->get_nodelist ) {
+						my $perm = findValue( $node, 'permission' );
+						if ( $perm ne 'all' ) {
+							$userDN = findValue( $node, 'principal' );
+						}
+					}
+				}
+				else {
+					$userDN = '';
+				}
+			}
+		}
+	}
+
+	# give the system a chance to finish databasing and indexing
+	sleep(5);
+
+	# send notification to the user and the moderator
+	if ( $errorMessage eq '' ) {
+		modSendNotification(
+			$title,       $contactEmailAddress,
+			$contactName, "Document $docid Accepted"
+		);
+		if ( $FORM::review ne '' ) {
+			$errorMessage = modStoreReview( 'accept', $metacat, $userDN );
+			if ( $errorMessage ne '' ) {
+				processResultTemplate( 'accept', 'failure', $errorMessage );
+				return;
+			}
+		}
+
+		# send notifications
+		processResultTemplate( 'accept', 'success', $errorMessage );
+	}
+	else {
+		processResultTemplate( 'accept', 'failure', $errorMessage );
+	}
 }
 
 ################################################################################
-# 
-# function to handle decline request for moderator  
 #
+# function to handle decline request for moderator
+#
 ################################################################################
-sub handleModDecline(){
+sub handleModDecline() {
 
-    my $errorMessage = '';
-    my $userDN = '';
-    my $metacat = Metacat->new($metacatUrl);
-    my $docid = $FORM::docid;
+	my $errorMessage = '';
+	my $userDN       = '';
+	my $metacat      = Metacat->new($metacatUrl);
+	my $docid        = $FORM::docid;
 
-    print "Content-type: text/html\n\n";
+	print "Content-type: text/html\n\n";
 
-    debug("Stage is mod_decline");
+	debug("Stage is mod_decline");
 
-    if (isModerator('decline') < 0) {
-        return;
-    }
+	if ( isModerator('decline') < 0 ) {
+		return;
+	}
 
-    # variables for contact information
-    my $contactEmailAddress;
-    my $contactName;
-    my $title;
+	# variables for contact information
+	my $contactEmailAddress;
+	my $contactName;
+	my $title;
 
-    # Log into metacat
-    my $response = $metacat->login($modUsername, $modPassword);
-    
-    if (! $response) {
-        # Could not login
-        #push(@errorMessages, $metacat->getMessage());
-        $errorMessage = $errorMessage." Failed during moderator login.";
-    } else {
-        # read the document and get the contact name and address
-        my $parser = XML::LibXML->new();
+	# Log into metacat
+	my $response = $metacat->login( $modUsername, $modPassword );
 
-        $response = $metacat->read($docid);
-        my $doc = $response->content();
-        my $xmldoc = $parser->parse_string($doc);
+	if ( !$response ) {
 
-        if ($xmldoc eq "" || $doc=~ /<error/) {
-            # not able to parse
-            $errorMessage = $errorMessage." Error in reading the docid:".$docid;
-        } else {
-            my $findNodes = $xmldoc->findnodes('//dataset/contact');
-            if ($findNodes->size() > 0) {
-                # found contact email address
-                my $node = '';
-                foreach $node ($findNodes->get_nodelist) {
-                    $contactEmailAddress = findValue($node,'electronicMailAddress');
-                    my $surName = findValue($node,'individualName/surName');
-                    my $givenName = findValue($node,'individualName/givenName');
-                    my $organizationName = findValue($node,'organizaitionName');
+		# Could not login
+		#push(@errorMessages, $metacat->getMessage());
+		$errorMessage = $errorMessage . " Failed during moderator login.";
+	}
+	else {
 
-                    if ($surName ne '') {
-                        $contactName = $givenName.' '.$surName;
-                    } else {
-                        $contactName = $organizationName;
-                    }
-                }
-            } else {
-                $contactEmailAddress = '';
-            }
-            $findNodes = $xmldoc->findnodes('//dataset/title');
-            if ($findNodes->size() > 0) {
-                # found title
-                my $node = '';
-                foreach $node ($findNodes->get_nodelist) {
-                    $title = findValue($node,'../title');
-                }
-            } else {
-                $title = '';
-            }
+		# read the document and get the contact name and address
+		my $parser = XML::LibXML->new();
 
-            $findNodes = $xmldoc->findnodes('//access/allow');
-            if ($findNodes->size() > 0) {
-                # found allow
-                my $node = '';
-                foreach $node ($findNodes->get_nodelist) {
-                     my $perm = findValue($node,'permission');
-                     if ($perm ne 'all') {
-                          $userDN = findValue($node,'principal');
-                     }
-                }
-            } else {
-                $userDN = '';
-            }
-        }
+		$response = $metacat->read($docid);
+		my $doc    = $response->content();
+		my $xmldoc = $parser->parse_string($doc);
 
-        $response = $metacat->delete($docid);
-        if (!$response) {
-            debug("Error while deleting document in handleModDecline.");
-            #push(@errorMessages, $metacat->getMessage());
-            $errorMessage = $errorMessage." Failed during deleting $docid. Please check if you are authorized to delete this document or if the document is not already deleted."; 
-        } else {
-            debug("Document deleted by handleModDecline is " . $docid);
-        }
-    }
+		if ( $xmldoc eq "" || $doc =~ /<error/ ) {
 
-    if ($errorMessage eq '') {
-        modSendNotification($title, $contactEmailAddress, $contactName, "Document $docid Rejected");
-        if ($FORM::review ne '') {
-            $errorMessage = modStoreReview('decline', $metacat, $userDN);
-            if ($errorMessage ne '') {
-                processResultTemplate('decline', 'failure', $errorMessage);
-                return;
-            }
-        }
-        # send notifications
-        processResultTemplate('decline', 'success', $errorMessage);
-    } else {
-        processResultTemplate('decline', 'failure', $errorMessage);
-    }
+			# not able to parse
+			$errorMessage =
+			  $errorMessage . " Error in reading the docid:" . $docid;
+		}
+		else {
+			my $findNodes = $xmldoc->findnodes('//dataset/contact');
+			if ( $findNodes->size() > 0 ) {
+
+				# found contact email address
+				my $node = '';
+				foreach $node ( $findNodes->get_nodelist ) {
+					$contactEmailAddress =
+					  findValue( $node, 'electronicMailAddress' );
+					my $surName = findValue( $node, 'individualName/surName' );
+					my $givenName =
+					  findValue( $node, 'individualName/givenName' );
+					my $organizationName =
+					  findValue( $node, 'organizaitionName' );
+
+					if ( $surName ne '' ) {
+						$contactName = $givenName . ' ' . $surName;
+					}
+					else {
+						$contactName = $organizationName;
+					}
+				}
+			}
+			else {
+				$contactEmailAddress = '';
+			}
+			$findNodes = $xmldoc->findnodes('//dataset/title');
+			if ( $findNodes->size() > 0 ) {
+
+				# found title
+				my $node = '';
+				foreach $node ( $findNodes->get_nodelist ) {
+					$title = findValue( $node, '../title' );
+				}
+			}
+			else {
+				$title = '';
+			}
+
+			$findNodes = $xmldoc->findnodes('//access/allow');
+			if ( $findNodes->size() > 0 ) {
+
+				# found allow
+				my $node = '';
+				foreach $node ( $findNodes->get_nodelist ) {
+					my $perm = findValue( $node, 'permission' );
+					if ( $perm ne 'all' ) {
+						$userDN = findValue( $node, 'principal' );
+					}
+				}
+			}
+			else {
+				$userDN = '';
+			}
+		}
+
+		$response = $metacat->delete($docid);
+		if ( !$response ) {
+			debug("Error while deleting document in handleModDecline.");
+
+			#push(@errorMessages, $metacat->getMessage());
+			$errorMessage = $errorMessage
+			  . " Failed during deleting $docid. Please check if you are authorized to delete this document or if the document is not already deleted.";
+		}
+		else {
+			debug( "Document deleted by handleModDecline is " . $docid );
+		}
+	}
+
+	if ( $errorMessage eq '' ) {
+		modSendNotification(
+			$title,       $contactEmailAddress,
+			$contactName, "Document $docid Rejected"
+		);
+		if ( $FORM::review ne '' ) {
+			$errorMessage = modStoreReview( 'decline', $metacat, $userDN );
+			if ( $errorMessage ne '' ) {
+				processResultTemplate( 'decline', 'failure', $errorMessage );
+				return;
+			}
+		}
+
+		# send notifications
+		processResultTemplate( 'decline', 'success', $errorMessage );
+	}
+	else {
+		processResultTemplate( 'decline', 'failure', $errorMessage );
+	}
 }
 
 ################################################################################
-# 
-# function to handle revise request for moderator  
 #
+# function to handle revise request for moderator
+#
 ################################################################################
-sub handleModRevise(){
-    my $errorMessage = '';
-    my $metacat = Metacat->new($metacatUrl);
-    my $docid = $FORM::docid;
+sub handleModRevise() {
+	my $errorMessage = '';
+	my $metacat      = Metacat->new($metacatUrl);
+	my $docid        = $FORM::docid;
 
-    print "Content-type: text/html\n\n";
+	print "Content-type: text/html\n\n";
 
-    debug("Stage is mod_revise");
+	debug("Stage is mod_revise");
 
-    if (isModerator('revise') < 0) {
-        return;
-    }
+	if ( isModerator('revise') < 0 ) {
+		return;
+	}
 
-    # variables for contact information
-    my $contactEmailAddress;
-    my $contactName;
-    my $title;
-    my $userDN = '';
+	# variables for contact information
+	my $contactEmailAddress;
+	my $contactName;
+	my $title;
+	my $userDN = '';
 
-    # Log into metacat
-    my $response = $metacat->login($modUsername, $modPassword);
+	# Log into metacat
+	my $response = $metacat->login( $modUsername, $modPassword );
 
-    if (! $response) {
-        # Could not login
-        #push(@errorMessages, $metacat->getMessage());
-        $errorMessage = $errorMessage." Failed during moderator login.";
+	if ( !$response ) {
 
-    } else {
-        # read the document and get the contact name and address
-        my $parser = XML::LibXML->new();
+		# Could not login
+		#push(@errorMessages, $metacat->getMessage());
+		$errorMessage = $errorMessage . " Failed during moderator login.";
 
-        $response = $metacat->read($docid);
-        my $doc = $response->content();
-        my $xmldoc = $parser->parse_string($doc);
-        $xmldoc = transformEml($xmldoc); 
-        if ($xmldoc eq "" || $doc=~ /<error/) {
-            # not able to parse
-            $errorMessage = $errorMessage." Error in reading the docid:".$docid;
-        } else {
-            $xmldoc = transformEml($xmldoc);
-            my $findNodes = $xmldoc->findnodes('//dataset/contact');
-            if ($findNodes->size() > 0) {
-                # found contact email address
-                my $node = '';
-                foreach $node ($findNodes->get_nodelist) {
-                    $contactEmailAddress = findValue($node,'electronicMailAddress');
+	}
+	else {
 
-                    my $surName = findValue($node,'individualName/surName');
-                    my $givenName = findValue($node,'individualName/givenName');
-                    my $organizationName = findValue($node,'organizaitionName');
+		# read the document and get the contact name and address
+		my $parser = XML::LibXML->new();
 
-                    if ($surName ne '') {
-                        $contactName = $givenName.' '.$surName;
-                    } else {
-                        $contactName = $organizationName;
-                    }
-                }
-            } else {
-                $contactEmailAddress = '';
-            }
+		$response = $metacat->read($docid);
+		my $doc    = $response->content();
+		my $xmldoc = $parser->parse_string($doc);
+		$xmldoc = transformEml($xmldoc);
+		if ( $xmldoc eq "" || $doc =~ /<error/ ) {
 
-            $findNodes = $xmldoc->findnodes('//dataset/title');
-            if ($findNodes->size() > 0) {
-                # found title
-                my $node = '';
-                foreach $node ($findNodes->get_nodelist) {
-                    $title = findValue($node,'../title');
-                }
-            } else {
-                $title = '';
-            }
+			# not able to parse
+			$errorMessage =
+			  $errorMessage . " Error in reading the docid:" . $docid;
+		}
+		else {
+			$xmldoc = transformEml($xmldoc);
+			my $findNodes = $xmldoc->findnodes('//dataset/contact');
+			if ( $findNodes->size() > 0 ) {
 
-            $findNodes = $xmldoc->findnodes('//access/allow');
-            if ($findNodes->size() > 0) {
-                # found title
-                my $node = '';
-                foreach $node ($findNodes->get_nodelist) {
-                    my $perm = findValue($node,'permission');
-                    if ($perm ne 'all') {
-                        $userDN = findValue($node,'principal');
-                    }
-                }
-            } else {
-                $userDN = '';
-            }
-        }
-        
-        my $emldoc = '';
-        my $dataElem = '';
-        my $accessElem = '';
+				# found contact email address
+				my $node = '';
+				foreach $node ( $findNodes->get_nodelist ) {
+					$contactEmailAddress =
+					  findValue( $node, 'electronicMailAddress' );
 
-        # pull out existing dataset entry 
-        my $results = $xmldoc->findnodes('/eml:eml/dataset');
-        foreach my $r ($results->get_nodelist) {
-            $dataElem .= $r->toString();
-        }
-        # also grab the access element
-        $results = $xmldoc->findnodes('/eml:eml/access');
-        foreach my $r ($results->get_nodelist) {
-          $accessElem .= $r->toString();
-        }
-    
-        my $addlMetadata = qq|
+					my $surName = findValue( $node, 'individualName/surName' );
+					my $givenName =
+					  findValue( $node, 'individualName/givenName' );
+					my $organizationName =
+					  findValue( $node, 'organizaitionName' );
+
+					if ( $surName ne '' ) {
+						$contactName = $givenName . ' ' . $surName;
+					}
+					else {
+						$contactName = $organizationName;
+					}
+				}
+			}
+			else {
+				$contactEmailAddress = '';
+			}
+
+			$findNodes = $xmldoc->findnodes('//dataset/title');
+			if ( $findNodes->size() > 0 ) {
+
+				# found title
+				my $node = '';
+				foreach $node ( $findNodes->get_nodelist ) {
+					$title = findValue( $node, '../title' );
+				}
+			}
+			else {
+				$title = '';
+			}
+
+			$findNodes = $xmldoc->findnodes('//access/allow');
+			if ( $findNodes->size() > 0 ) {
+
+				# found title
+				my $node = '';
+				foreach $node ( $findNodes->get_nodelist ) {
+					my $perm = findValue( $node, 'permission' );
+					if ( $perm ne 'all' ) {
+						$userDN = findValue( $node, 'principal' );
+					}
+				}
+			}
+			else {
+				$userDN = '';
+			}
+		}
+
+		my $emldoc     = '';
+		my $dataElem   = '';
+		my $accessElem = '';
+
+		# pull out existing dataset entry
+		my $results = $xmldoc->findnodes('/eml:eml/dataset');
+		foreach my $r ( $results->get_nodelist ) {
+			$dataElem .= $r->toString();
+		}
+
+		# also grab the access element
+		$results = $xmldoc->findnodes('/eml:eml/access');
+		foreach my $r ( $results->get_nodelist ) {
+			$accessElem .= $r->toString();
+		}
+
+		my $addlMetadata = qq|
         <additionalMetadata>
             <metadata>
                 <moderatorComment>Revision Requested</moderatorComment>
             </metadata>
         </additionalMetadata>|;
-      
-        $emldoc .= EMLStart();
-        $emldoc .= $accessElem;
-        $emldoc .= $dataElem;
-        $emldoc .= $addlMetadata;
-        $emldoc .= EMLEnd();
-        
-        # update the document
-        my $docid = incrementRevision($docid);
 
-        $emldoc =~ s/packageId="docid"/packageId="$docid"/;
-        debugDoc($emldoc);
-        $response = $metacat->update($docid, $emldoc);
+		$emldoc .= EMLStart();
+		$emldoc .= $accessElem;
+		$emldoc .= $dataElem;
+		$emldoc .= $addlMetadata;
+		$emldoc .= EMLEnd();
 
-        if (!$response) {
-            debug("Error while updating in handleModAccept.".$metacat->getMessage());
-            $errorMessage = $errorMessage." Failed while updating the document with additional metadata.";
-        }
+		# update the document
+		my $docid = incrementRevision($docid);
 
-    }
-    if ($errorMessage eq '') {
-        modSendNotification($title, $contactEmailAddress, $contactName, "Revise document: $docid");
-        if ($FORM::review ne '') {
-            $errorMessage = modStoreReview('revise', $metacat, $userDN);
-            if ($errorMessage ne '') {
-                processResultTemplate('revise', 'failure', $errorMessage);
-                return;
-            }
-        }
-        # send notifications
-        processResultTemplate('revise', 'success', $errorMessage);
-    } else {
-        processResultTemplate('revise', 'failure', $errorMessage);
-    }
+		$emldoc =~ s/packageId="docid"/packageId="$docid"/;
+		debugDoc($emldoc);
+		$response = $metacat->update( $docid, $emldoc );
+
+		if ( !$response ) {
+			debug( "Error while updating in handleModAccept."
+				  . $metacat->getMessage() );
+			$errorMessage = $errorMessage
+			  . " Failed while updating the document with additional metadata.";
+		}
+
+	}
+	if ( $errorMessage eq '' ) {
+		modSendNotification(
+			$title,       $contactEmailAddress,
+			$contactName, "Revise document: $docid"
+		);
+		if ( $FORM::review ne '' ) {
+			$errorMessage = modStoreReview( 'revise', $metacat, $userDN );
+			if ( $errorMessage ne '' ) {
+				processResultTemplate( 'revise', 'failure', $errorMessage );
+				return;
+			}
+		}
+
+		# send notifications
+		processResultTemplate( 'revise', 'success', $errorMessage );
+	}
+	else {
+		processResultTemplate( 'revise', 'failure', $errorMessage );
+	}
 }
 
 sub modStoreReview {
-    my $action = shift;
-    my $metacat = shift;
-    my $userDN = shift;
-    
-    my $gmt = gmtime($now);
-    my $docid = $FORM::docid;
-    my $parser = XML::LibXML->new();
+	my $action  = shift;
+	my $metacat = shift;
+	my $userDN  = shift;
 
-    # create the xml part that has to be inserted
-    my $review = qq|
+	my $gmt    = gmtime($now);
+	my $docid  = $FORM::docid;
+	my $parser = XML::LibXML->new();
+
+	# create the xml part that has to be inserted
+	my $review = qq|
     <review>
       <packageId>$docid</packageId>
       <action>$action</action>
